#include <iostream>
#include <fstream>
#include <math.h>
#include <iomanip>

using namespace std;

class egyenlet{
private:
    float **a,*b,d;
    int n,*indx;
    void ludcmp(float **, int , int *, float *);
    void lubksb(float **, int , int *, float []);
public:
    egyenlet(const char*,const char*);
    void solve();
};

egyenlet::egyenlet(const char* matrix,const char* vektor){    
    ifstream be1(vektor);
    n=0;
    float x;
    while(!be1.eof()){be1>>x; n++;}
    a=new float *[n+1];
    for(int i=1;i<=n;i++) a[i]=new float [n+1];
    b=new float [n+1];
    indx=new int [n+3];
    be1.close();
    be1.open(vektor,ios_base::in);
    for(int i=1;i<=n;i++) be1>>b[i];
    be1.close();
    ifstream be2(matrix);
    for(int i=1;i<=n;i++)
	for(int j=1;j<=n;j++) be2>>a[i][j];
    be2.close();
    cout<<"Az egyenletrendszer m'atrixa:\n";
    for(int i=1;i<=n;i++){
	for(int j=1;j<=n;j++) cout<<setw(10)<<a[i][j]; 
	cout<<endl;
    }    
    cout<<"Az egyenletrendszer jobboldala:\n";
    for(int i=1;i<=n;i++) cout<<setw(10)<<b[i]<<endl;
}



void egyenlet::ludcmp(float **a, int n, int *indx, float *d)
{
	int i,imax,j,k;
	float big,dum,sum,temp;
	float *vv;

const float TINY=1.0e-20;

	vv=new float[n+1];
	*d=1.0;
	for (i=1;i<=n;i++) {
		big=0.0;
		for (j=1;j<=n;j++)
			if ((temp=fabs(a[i][j])) > big) big=temp;
		if (big == 0.0) cerr<<"Singular matrix in routine ludcmp"<<endl;
		vv[i]=1.0/big;
	}
	for (j=1;j<=n;j++) {
		for (i=1;i<j;i++) {
			sum=a[i][j];
			for (k=1;k<i;k++) sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
		}
		big=0.0;
		for (i=j;i<=n;i++) {
			sum=a[i][j];
			for (k=1;k<j;k++)
				sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
			if ( (dum=vv[i]*fabs(sum)) >= big) {
				big=dum;
				imax=i;
			}
		}
		if (j != imax) {
			for (k=1;k<=n;k++) {
				dum=a[imax][k];
				a[imax][k]=a[j][k];
				a[j][k]=dum;
			}
			*d = -(*d);
			vv[imax]=vv[j];
		}
		indx[j]=imax;
		if (a[j][j] == 0.0) a[j][j]=TINY;
		if (j != n) {
			dum=1.0/(a[j][j]);
			for (i=j+1;i<=n;i++) a[i][j] *= dum;
		}
	}
	delete [] vv;
}

void egyenlet::lubksb(float **a, int n, int *indx, float b[])
{
	int i,ii=0,ip,j;
	float sum;

	for (i=1;i<=n;i++) {
		ip=indx[i];
		sum=b[ip];
		b[ip]=b[i];
		if (ii)
			for (j=ii;j<=i-1;j++) sum -= a[i][j]*b[j];
		else if (sum) ii=i;
		b[i]=sum;
	}
	for (i=n;i>=1;i--) {
		sum=b[i];
		for (j=i+1;j<=n;j++) sum -= a[i][j]*b[j];
		b[i]=sum/a[i][i];
	}
}

void egyenlet::solve(){

ludcmp(a,n,indx,&d);
lubksb(a,n,indx,b);

cout<<"Az egyenletrendszer megolda'sa:\n";
for(int i=1;i<=n;i++) cout<<setw(10)<<b[i]<<endl;

}



int main(){
    egyenlet proba("a_float.dat","b_float.dat");
    proba.solve();

}
